//****************************//
//                            //
//  FtpClient Ver: 1.0        //
//  Copyright: Sam Zhao       //
//  2004 Niigata City Japan   //
//                            //
//****************************//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
//ǉO
using System.IO;
using System.Net;
using System.Text;
using System.Threading;
using System.Net.Sockets;
using System.Text.RegularExpressions;

namespace FtpClient
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.ListView listView_Local;
		private System.Windows.Forms.ListView listView_Remote;
		private System.Windows.Forms.TextBox tbox_Show;
		private System.Windows.Forms.TextBox tbox_LocalPath;
		private System.Windows.Forms.TextBox tbox_RemotePath;
		private System.Windows.Forms.Button btn_Disconnect;
		private System.Windows.Forms.Button btn_Connect;
		private System.Windows.Forms.RadioButton rbtn_Port;
		private System.Windows.Forms.RadioButton rbtn_Pasv;
		private System.Windows.Forms.TextBox tbox_Host;
		private System.Windows.Forms.TextBox tbox_Port;
		private System.Windows.Forms.TextBox tbox_User;
		private System.Windows.Forms.TextBox tbox_Pass;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.ColumnHeader columnHeader5;
		private System.Windows.Forms.ColumnHeader columnHeader6;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ContextMenu contextMenu_Local;
		private System.Windows.Forms.ContextMenu contextMenu_Remote;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;

		//gϐ̒ǉ
		private string Temp = "";
		private ListViewItem lvi;
		private string LocalPath = "";
		private bool Download = false;
		private bool isConnect = false;
		private string RemotePath = "/";
		private string MsgFromServer = "";
		private string UploadFileName = "";
		private string DownloadFileName = "";
		private TcpClient tcpClient_Ctrl = null;
		private NetworkStream netStream_Ctrl = null;

		public Form1()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.panel1 = new System.Windows.Forms.Panel();
			this.tbox_Show = new System.Windows.Forms.TextBox();
			this.panel2 = new System.Windows.Forms.Panel();
			this.label4 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.rbtn_Pasv = new System.Windows.Forms.RadioButton();
			this.rbtn_Port = new System.Windows.Forms.RadioButton();
			this.tbox_Pass = new System.Windows.Forms.TextBox();
			this.tbox_User = new System.Windows.Forms.TextBox();
			this.tbox_Port = new System.Windows.Forms.TextBox();
			this.tbox_Host = new System.Windows.Forms.TextBox();
			this.tbox_RemotePath = new System.Windows.Forms.TextBox();
			this.tbox_LocalPath = new System.Windows.Forms.TextBox();
			this.btn_Disconnect = new System.Windows.Forms.Button();
			this.btn_Connect = new System.Windows.Forms.Button();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.panel3 = new System.Windows.Forms.Panel();
			this.listView_Local = new System.Windows.Forms.ListView();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.contextMenu_Local = new System.Windows.Forms.ContextMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.panel4 = new System.Windows.Forms.Panel();
			this.listView_Remote = new System.Windows.Forms.ListView();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.contextMenu_Remote = new System.Windows.Forms.ContextMenu();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.label3 = new System.Windows.Forms.Label();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.panel3.SuspendLayout();
			this.panel4.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.tbox_Show);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel1.Location = new System.Drawing.Point(0, 350);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(504, 104);
			this.panel1.TabIndex = 0;
			// 
			// tbox_Show
			// 
			this.tbox_Show.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tbox_Show.Location = new System.Drawing.Point(0, 0);
			this.tbox_Show.Multiline = true;
			this.tbox_Show.Name = "tbox_Show";
			this.tbox_Show.ReadOnly = true;
			this.tbox_Show.Size = new System.Drawing.Size(504, 104);
			this.tbox_Show.TabIndex = 0;
			this.tbox_Show.Text = "";
			// 
			// panel2
			// 
			this.panel2.Controls.Add(this.label4);
			this.panel2.Controls.Add(this.label2);
			this.panel2.Controls.Add(this.label1);
			this.panel2.Controls.Add(this.rbtn_Pasv);
			this.panel2.Controls.Add(this.rbtn_Port);
			this.panel2.Controls.Add(this.tbox_Pass);
			this.panel2.Controls.Add(this.tbox_User);
			this.panel2.Controls.Add(this.tbox_Port);
			this.panel2.Controls.Add(this.tbox_Host);
			this.panel2.Controls.Add(this.tbox_RemotePath);
			this.panel2.Controls.Add(this.tbox_LocalPath);
			this.panel2.Controls.Add(this.btn_Disconnect);
			this.panel2.Controls.Add(this.btn_Connect);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel2.Location = new System.Drawing.Point(0, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(504, 112);
			this.panel2.TabIndex = 1;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(248, 45);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(32, 23);
			this.label4.TabIndex = 12;
			this.label4.Text = "Pass";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(88, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(32, 23);
			this.label2.TabIndex = 11;
			this.label2.Text = "Port";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(88, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 23);
			this.label1.TabIndex = 10;
			this.label1.Text = "Host";
			// 
			// rbtn_Pasv
			// 
			this.rbtn_Pasv.Checked = true;
			this.rbtn_Pasv.Location = new System.Drawing.Point(400, 44);
			this.rbtn_Pasv.Name = "rbtn_Pasv";
			this.rbtn_Pasv.TabIndex = 9;
			this.rbtn_Pasv.TabStop = true;
			this.rbtn_Pasv.Text = "Pasv[h";
			// 
			// rbtn_Port
			// 
			this.rbtn_Port.Location = new System.Drawing.Point(400, 16);
			this.rbtn_Port.Name = "rbtn_Port";
			this.rbtn_Port.TabIndex = 8;
			this.rbtn_Port.Text = "Port[h";
			// 
			// tbox_Pass
			// 
			this.tbox_Pass.Location = new System.Drawing.Point(288, 48);
			this.tbox_Pass.Name = "tbox_Pass";
			this.tbox_Pass.PasswordChar = '*';
			this.tbox_Pass.TabIndex = 7;
			this.tbox_Pass.Text = "";
			// 
			// tbox_User
			// 
			this.tbox_User.Location = new System.Drawing.Point(288, 16);
			this.tbox_User.Name = "tbox_User";
			this.tbox_User.TabIndex = 6;
			this.tbox_User.Text = "";
			// 
			// tbox_Port
			// 
			this.tbox_Port.Location = new System.Drawing.Point(128, 48);
			this.tbox_Port.Name = "tbox_Port";
			this.tbox_Port.TabIndex = 5;
			this.tbox_Port.Text = "";
			// 
			// tbox_Host
			// 
			this.tbox_Host.Location = new System.Drawing.Point(128, 16);
			this.tbox_Host.Name = "tbox_Host";
			this.tbox_Host.TabIndex = 4;
			this.tbox_Host.Text = "";
			// 
			// tbox_RemotePath
			// 
			this.tbox_RemotePath.Location = new System.Drawing.Point(256, 80);
			this.tbox_RemotePath.Name = "tbox_RemotePath";
			this.tbox_RemotePath.ReadOnly = true;
			this.tbox_RemotePath.Size = new System.Drawing.Size(240, 19);
			this.tbox_RemotePath.TabIndex = 3;
			this.tbox_RemotePath.Text = "";
			// 
			// tbox_LocalPath
			// 
			this.tbox_LocalPath.Location = new System.Drawing.Point(8, 80);
			this.tbox_LocalPath.Name = "tbox_LocalPath";
			this.tbox_LocalPath.ReadOnly = true;
			this.tbox_LocalPath.Size = new System.Drawing.Size(232, 19);
			this.tbox_LocalPath.TabIndex = 2;
			this.tbox_LocalPath.Text = "";
			// 
			// btn_Disconnect
			// 
			this.btn_Disconnect.Location = new System.Drawing.Point(8, 48);
			this.btn_Disconnect.Name = "btn_Disconnect";
			this.btn_Disconnect.TabIndex = 1;
			this.btn_Disconnect.Text = "Disconnect";
			this.btn_Disconnect.Click += new System.EventHandler(this.btn_Disconnect_Click);
			// 
			// btn_Connect
			// 
			this.btn_Connect.Location = new System.Drawing.Point(8, 8);
			this.btn_Connect.Name = "btn_Connect";
			this.btn_Connect.TabIndex = 0;
			this.btn_Connect.Text = "Connect";
			this.btn_Connect.Click += new System.EventHandler(this.btn_Connect_Click);
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.splitter1.Location = new System.Drawing.Point(0, 347);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(504, 3);
			this.splitter1.TabIndex = 2;
			this.splitter1.TabStop = false;
			// 
			// panel3
			// 
			this.panel3.Controls.Add(this.listView_Local);
			this.panel3.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel3.Location = new System.Drawing.Point(0, 112);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(248, 235);
			this.panel3.TabIndex = 3;
			// 
			// listView_Local
			// 
			this.listView_Local.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																																										 this.columnHeader3,
																																										 this.columnHeader2,
																																										 this.columnHeader1});
			this.listView_Local.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView_Local.LabelEdit = true;
			this.listView_Local.Location = new System.Drawing.Point(0, 0);
			this.listView_Local.Name = "listView_Local";
			this.listView_Local.Size = new System.Drawing.Size(248, 235);
			this.listView_Local.SmallImageList = this.imageList1;
			this.listView_Local.TabIndex = 0;
			this.listView_Local.View = System.Windows.Forms.View.Details;
			this.listView_Local.DoubleClick += new System.EventHandler(this.listView_Local_DoubleClick);
			this.listView_Local.DragDrop += new System.Windows.Forms.DragEventHandler(this.listView_Local_DragDrop);
			this.listView_Local.AfterLabelEdit += new System.Windows.Forms.LabelEditEventHandler(this.listView_Local_AfterLabelEdit);
			this.listView_Local.DragEnter += new System.Windows.Forms.DragEventHandler(this.listView_Local_DragEnter);
			this.listView_Local.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.listView_Local_ItemDrag);
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "O";
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "TCY";
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "XV";
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// contextMenu_Local
			// 
			this.contextMenu_Local.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																											this.menuItem1,
																																											this.menuItem2,
																																											this.menuItem3});
			this.contextMenu_Local.Popup += new System.EventHandler(this.contextMenu_Local_Popup);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.Text = "";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.Text = "";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 2;
			this.menuItem3.Text = "";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(248, 112);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(3, 235);
			this.splitter2.TabIndex = 4;
			this.splitter2.TabStop = false;
			// 
			// panel4
			// 
			this.panel4.Controls.Add(this.listView_Remote);
			this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel4.Location = new System.Drawing.Point(251, 112);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(253, 235);
			this.panel4.TabIndex = 5;
			// 
			// listView_Remote
			// 
			this.listView_Remote.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																																											this.columnHeader4,
																																											this.columnHeader5,
																																											this.columnHeader6});
			this.listView_Remote.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView_Remote.LabelEdit = true;
			this.listView_Remote.Location = new System.Drawing.Point(0, 0);
			this.listView_Remote.Name = "listView_Remote";
			this.listView_Remote.Size = new System.Drawing.Size(253, 235);
			this.listView_Remote.SmallImageList = this.imageList1;
			this.listView_Remote.TabIndex = 0;
			this.listView_Remote.View = System.Windows.Forms.View.Details;
			this.listView_Remote.DoubleClick += new System.EventHandler(this.listView_Remote_DoubleClick);
			this.listView_Remote.DragDrop += new System.Windows.Forms.DragEventHandler(this.listView_Remote_DragDrop);
			this.listView_Remote.AfterLabelEdit += new System.Windows.Forms.LabelEditEventHandler(this.listView_Remote_AfterLabelEdit);
			this.listView_Remote.DragEnter += new System.Windows.Forms.DragEventHandler(this.listView_Remote_DragEnter);
			this.listView_Remote.ItemDrag += new System.Windows.Forms.ItemDragEventHandler(this.listView_Remote_ItemDrag);
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "O";
			// 
			// columnHeader5
			// 
			this.columnHeader5.Text = "TCY";
			// 
			// columnHeader6
			// 
			this.columnHeader6.Text = "XV";
			// 
			// contextMenu_Remote
			// 
			this.contextMenu_Remote.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																											 this.menuItem4,
																																											 this.menuItem5,
																																											 this.menuItem6});
			this.contextMenu_Remote.Popup += new System.EventHandler(this.contextMenu_Remote_Popup);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.Text = "";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 1;
			this.menuItem5.Text = "";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 2;
			this.menuItem6.Text = "";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(248, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(32, 23);
			this.label3.TabIndex = 11;
			this.label3.Text = "User";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(504, 454);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.panel4);
			this.Controls.Add(this.splitter2);
			this.Controls.Add(this.panel3);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.panel4.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
    // Connect {^
		private void btn_Connect_Click(object sender, System.EventArgs e)
		{
			tbox_Show.Text = "";
			RemotePath = "/";
			login();
			if(isConnect)
			{
				LocalPath = Directory.GetCurrentDirectory();
				LocalFileList(LocalPath);
				RemoteFileList();
				listView_Local.AllowDrop = true;
				listView_Remote.AllowDrop = true;
				listView_Local.ContextMenu = contextMenu_Local;
				listView_Remote.ContextMenu = contextMenu_Remote;
			}
		}
		// Disconnect {^
		private void btn_Disconnect_Click(object sender, System.EventArgs e)
		{
			if(isConnect)
			{
				if(SendToServer("QUIT"))
				{
					GetMessage();
					Disconnect();
					listView_Local.Items.Clear();
					tbox_LocalPath.Text = "";
					listView_Remote.Items.Clear();
					listView_Local.ContextMenu = null;
					listView_Remote.ContextMenu = null;
					tbox_RemotePath.Text = "";
				}
				else
				{
					Disconnect();
					listView_Local.Items.Clear();
					tbox_LocalPath.Text = "";
					listView_Remote.Items.Clear();
					tbox_RemotePath.Text = "";
					listView_Local.ContextMenu = null;
					listView_Remote.ContextMenu = null;
				}
			}
			else
			{}
		}
		// ڑ  F
		private void login()
		{
			HostInfo hostInfo = new HostInfo();
			if(tbox_Host.Text != string.Empty)
				hostInfo.HostName = tbox_Host.Text;
			if(tbox_Port.Text != string.Empty)
				hostInfo.Port = int.Parse(tbox_Port.Text);

			if(tbox_User.Text != string.Empty)
				hostInfo.User = tbox_User.Text;
			if(tbox_Pass.Text != string.Empty)
				hostInfo.Pass = tbox_Pass.Text;
      //Rg[RlNV̊mB
			try
			{
				tcpClient_Ctrl = new TcpClient(hostInfo.HostName,hostInfo.Port);
				tbox_Show.AppendText("Connected to "+ hostInfo.HostName + "\r\n");
				isConnect = true;
				btn_Connect.Enabled = false;
			}
			catch(Exception ex)
			{
				tbox_Show.AppendText(ex.Message + "\r\n");
				return;
			}
			netStream_Ctrl = tcpClient_Ctrl.GetStream();
			if(GetMessage()!=220)
			{
				Disconnect();
				return;
			}
			//F؂
			SendToServer("USER "+hostInfo.User);
			int check=GetMessage();
			if(!(check==331 || check==230))
			{
				Disconnect();
				return;
			}
			if(check==331)
			{
				SendToServer("PASS "+hostInfo.Pass);
				check=GetMessage();
				if(check!=230)
				{
					Disconnect();
					return;
				}
			}
			SendToServer("CWD "+RemotePath);
			GetMessage();
		}
		// Rg[RlNVؒfB
		private void Disconnect()
		{
			try
			{
				tcpClient_Ctrl.Close();
				isConnect = false;
				btn_Connect.Enabled = true;
				tbox_Show.AppendText("Connection was canceled \r\n");
			}
			catch(Exception ex)
			{
				tbox_Show.AppendText(ex.Message + "\r\n");
			}
		}
		//T[oɑM
		private bool SendToServer(string command)
		{
			string msg = command + "\r\n";
			tbox_Show.AppendText(">>> " + msg);
			byte[] bb = new byte[1024];
			bb = Encoding.ASCII.GetBytes(msg.ToCharArray());
			try
			{
				netStream_Ctrl.Write(bb,0,bb.Length);
				netStream_Ctrl.Flush();
				return true;
			}
			catch(Exception ex)
			{
				tbox_Show.AppendText(ex.Message + "\r\n");
				return false;
			}
		}
		//񓚃bZ[WMB
		private int GetMessage()
		{
			int Code=0;
			int LastCode=0;
			string temp ="";
			string msg = "";
			Thread.Sleep(800);
			StreamReader sr = new StreamReader(netStream_Ctrl,Encoding.ASCII);
			//Thread.Sleep(800) 800~b҂Ăf[^ȂꍇAMLZB
			if(!netStream_Ctrl.DataAvailable)
				return 0;
			try
			{
				while((temp=sr.ReadLine())!=null)
				{				
					tbox_Show.AppendText(temp + "\r\n");
					msg = msg + temp;
					try
					{
						LastCode = int.Parse(temp.Substring(0,3));
					}
					catch
					{
						LastCode = 0;
					}
					if((LastCode != 0) && temp.Substring(3,1).Equals(" "))
						break;
				}
				Code = int.Parse(msg.Substring(0,3));
				MsgFromServer = msg;
			}
			catch
			{
				tbox_Show.AppendText("MłȂAf܂!\r\n");
				Code = 0;
			}
			return Code;
		}
		//[Jt@CƃhCuꗗB
		private void LocalFileList(string path)
		{
			listView_Local.Items.Clear();
			tbox_LocalPath.Text = path;
			ListViewItem listViewItem;
			try
			{
				//efBNgǉ
				listViewItem = new ListViewItem("..",1);
				listView_Local.Items.Add(listViewItem);
				//tH_ꗗ
				DirectoryInfo DI;
				DI = new DirectoryInfo(path);
				foreach(DirectoryInfo dir in DI.GetDirectories())
				{
					listViewItem = new ListViewItem(dir.Name,1);
					listViewItem.SubItems.Add(" ");
					listViewItem.SubItems.Add(" ");
					listViewItem.SubItems.Add("1");
					listView_Local.Items.Add(listViewItem);
				}
				//t@Cꗗ
				foreach(FileInfo fi in DI.GetFiles())
				{
					listViewItem = new ListViewItem(fi.Name,2);
					listViewItem.SubItems.Add(fi.Length.ToString());
					listViewItem.SubItems.Add(fi.LastWriteTime.ToString());
					listViewItem.SubItems.Add("2");
					listView_Local.Items.Add(listViewItem);
				}
			}
			catch(IOException)
			{
				tbox_Show.AppendText("fBXNĂȂA݂Ȃ̂ŁAANZXł܂\r\n");
			}
			catch (UnauthorizedAccessException)
			{
				tbox_Show.AppendText("ANZXł܂\r\n");
			}
			catch (Exception ee)
			{
				tbox_Show.AppendText(ee.Message+"\r\n");
			}
			//hCuꗗ
			foreach(string drive in Directory.GetLogicalDrives())
			{
				listViewItem = new ListViewItem(drive,0);
				listViewItem.SubItems.Add(" ");
				listViewItem.SubItems.Add(" ");
				listViewItem.SubItems.Add("0");
				listView_Local.Items.Add(listViewItem);

			}
		}
		//JghCuAfBNg̕ύX
		private void listView_Local_DoubleClick(object sender, System.EventArgs e)
		{
			string myItem = listView_Local.SelectedItems[0].Text;
			string path = "";
			if(Directory.Exists((Directory.GetCurrentDirectory())+"\\" +myItem))
			{
				Directory.SetCurrentDirectory(Directory.GetCurrentDirectory() + "\\" + myItem);
				try
				{
					path = Directory.GetCurrentDirectory();
					LocalFileList(path);
				}
				catch(Exception ee)
				{
					tbox_Show.AppendText(ee.Message+"\r\n");
				}

			}
			if(Path.IsPathRooted(myItem))
			{
				try
				{
					Directory.SetCurrentDirectory(myItem);
					path = Directory.GetCurrentDirectory();
					LocalFileList(path);
				}
				catch(IOException)
				{
					tbox_Show.AppendText("ANZXł܂\r\n");
				}
				catch(Exception ee)
				{
					tbox_Show.AppendText(ee.Message+"\r\n");
				}
			}		
		}
		//T[õJgfBNg̕ύX
		private void listView_Remote_DoubleClick(object sender, System.EventArgs e)
		{
			string DirName = listView_Remote.SelectedItems[0].SubItems[3].Text;
			if(DirName=="2")
			{
				return;
			}
			DirName = listView_Remote.SelectedItems[0].Text;
			if(!SendToServer("CWD "+DirName))
			{
				return;
			}
			GetMessage();
			RemoteFileList();
		
		}
		private void RemoteFileList()
		{
			if(rbtn_Pasv.Checked)
			{
				PasvFileList();
			}
			else
			{
				PortFileList();
			}
		}
		//Pasv[hŃT[õt@Cꗗ擾
		private void PasvFileList()
		{
			GetRemotePath();
			IPEndPoint Server = null;
			Server = PasvServerInfo();
			if(Server==null)
				return;
			Socket socket = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);
			try
			{
				socket.Connect(Server);
			}
			catch
			{
			  tbox_Show.AppendText("f[^RlNVmł܂\r\n");
				return;
			}
			SendToServer("LIST");
			MakeViewIcon(ReadListFromServer(ref socket));
			GetMessage();
		}
		//Port[hŃT[õt@Cꗗ擾
		private void PortFileList()
		{
			GetRemotePath();
			TcpListener tcpListener = new TcpListener(LocalIP(),0);
			tcpListener.Start();
			SendToServer("PORT "+LocalInfo(tcpListener));
			if(GetMessage()!=200)
				return;
			if(!SendToServer("LIST"))
				return;
			Socket sock = tcpListener.AcceptSocket();
			MakeViewIcon(ReadListFromServer(ref sock));
			GetMessage();
			tcpListener.Stop();
			tcpListener = null;
		}
		//[JIPAhX擾
		private IPAddress LocalIP()
		{
			IPAddress LocalIP;
			try
			{ 
				LocalIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[1];
			}
			catch
			{
				LocalIP = Dns.GetHostByName(Dns.GetHostName()).AddressList[0];
			}
			return LocalIP;
		}
		//[JIPƑҋ@|[g𕶎ɕϊ
		private string LocalInfo(TcpListener tcpListener)
		{
			string LocalIPS = LocalIP().ToString();
			LocalIPS = LocalIPS.Replace(".",",");
			IPEndPoint ipend = (IPEndPoint)tcpListener.LocalEndpoint;
			int temp1 = ipend.Port /256;
			int temp2 = ipend.Port % 256;
			return LocalIPS + "," + temp1.ToString() + "," + temp2.ToString();
		}
		//Pasv[h̎AT[oIPƑҋ@|[g擾
		private IPEndPoint PasvServerInfo()
		{
			if(!SendToServer("PASV"))
				return null;
			if(GetMessage()!=227)
			{
				tbox_Show.AppendText("PASV [h̓T|[g܂ \r\n");
				return null;
			}
			int f = MsgFromServer.IndexOf('(');
			int b = MsgFromServer.IndexOf(')');
			string Server = MsgFromServer.Substring(f+1,b-f-1);
			string [] temp = Server.Split(',');
			string ServerIP = temp[0] + "." +
				                temp[1] + "." +
				                temp[2] + "." +
				                temp[3];
			int ServerPort = int.Parse(temp[4]) * 256 + int.Parse(temp[5]);
			IPEndPoint myEndPoint = new IPEndPoint(IPAddress.Parse(ServerIP),ServerPort);
      return myEndPoint;
		}
		//T[õJgfBNg̃tp[X擾
		private void GetRemotePath()
		{
			if(!SendToServer("PWD"))
				return;
			GetMessage();
			try
			{
				int x = MsgFromServer.IndexOf('"');
				int y = MsgFromServer.IndexOf('"',x+1);
				RemotePath = MsgFromServer.Substring(x+1,y-x-1);
				tbox_RemotePath.Text = RemotePath;
			}
			catch
			{}
		}
		//T[o當f[^M
		private string ReadListFromServer(ref Socket socket)
		{
			string output = "";
			string tempS = "";
			int count = 0;
			byte[] bb = new byte[256];
			for(;(count=socket.Receive(bb))>0;)
			{
				tempS = Encoding.ASCII.GetString(bb,0,count);
				output += tempS;
				if(socket.Available==0)
					break;
			}
			try
			{
				socket.Shutdown(SocketShutdown.Both);
				socket.Close();
			}
			catch
			{}
			return output;
		}
		//listViewRg[ɃACe\
		private void MakeViewIcon(string msg)
		{
			
			listView_Remote.Items.Clear();
			//efBNgǉ
			ListViewItem listViewItem;
			listViewItem = new ListViewItem("..",1);
			listViewItem.SubItems.Add(" ");
			listViewItem.SubItems.Add(" ");
			listViewItem.SubItems.Add("1");
			listView_Remote.Items.Add(listViewItem);
			StringReader sr = new StringReader(msg);
			string Line ="";
			string [] check = null;
			while((Line=sr.ReadLine())!=null)
			{
				check = Line.Split(' ');
				if(check.Length<6)
					continue;
				if(Line.Substring(0,1).Equals("-"))
				{
					MakeNewItem(Line,2);
				}
				else if(Line.Substring(0,1).Equals("l"))
				{
					int i = Line.IndexOf("->");
					Line = Line.Substring(0,i);
					MakeNewItem(Line,1);
				}
				else
				{
					MakeNewItem(Line,1);
				}
			}

		}
		//listViewRg[ɃACe\
		private void MakeNewItem(string inputLine,int DirOrFile)
		{
			ListViewItem myItem;
			string filename = "";
			string filesize = "";
			string filedate = "";
			Regex regex = new Regex(@"(?<size>[0-9]{1,20})\s+(?<month>[A-Z]{1}[a-z]{2})\s+(?<day>[0-9]{1,2})\s+(?<yeartime>\S+)\s+(?<filename>\S+)");
			try
			{
				Match m= regex.Match(inputLine);
				filename = m.Result("${filename}");
				filesize = m.Result("${size}");
				filedate = m.Result("${month}") + "/"+m.Result("${day}")+"/ " + m.Result("${yeartime}");
			}
			catch
			{
			}
			myItem = new ListViewItem(filename,DirOrFile);
			myItem.SubItems.Add(filesize);
			myItem.SubItems.Add(filedate);
			myItem.SubItems.Add(DirOrFile.ToString());
			listView_Remote.Items.Add(myItem);
		}
		//][hZbg
		private void SetFileTransMode(string filename)
		{
			if(filename.IndexOf("txt")>0 ||
				 filename.IndexOf("ini")>0 ||
				 filename.IndexOf("bat")>0)
			{
				SendToServer("TYPE A");
				GetMessage();
			}
			else if(filename.IndexOf("exe")>0)
			{
				SendToServer("TYPE I");
				GetMessage();
			}
			else
			{
				SendToServer("TYPE I");
				GetMessage();
			}
		}
		/////////////////////////////////////////////////
		private void listView_Remote_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			Download = true;
			string check = listView_Remote.SelectedItems[0].SubItems[3].Text;
			if(check=="1")
				return;
			string filename = listView_Remote.SelectedItems[0].Text;
			listView_Remote.DoDragDrop(filename,DragDropEffects.Copy);
		}

		private void listView_Local_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			e.Effect = DragDropEffects.Copy;
		}

		private void listView_Local_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string filename = e.Data.GetData(DataFormats.Text).ToString();
			if(!Download)
				return;
			DownloadFileName = filename;
			Thread t = new Thread(new ThreadStart(DownloadFile));
			t.IsBackground = true;
			t.Start();
		}
		/////////////////////////////////////////////////
		private void listView_Local_ItemDrag(object sender, System.Windows.Forms.ItemDragEventArgs e)
		{
			try
			{
				Download = false;
				string check = listView_Local.SelectedItems[0].SubItems[3].Text;
				if(check=="1")
					return;
				string filename = listView_Local.SelectedItems[0].Text;
				listView_Local.DoDragDrop(filename,DragDropEffects.Copy);		
			}
			catch
			{}
		}

		private void listView_Remote_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			e.Effect = DragDropEffects.Copy;
		}

		private void listView_Remote_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			string filename = e.Data.GetData(DataFormats.Text).ToString();
			if(Download)
				return;
			UploadFileName = filename;
			Thread t = new Thread(new ThreadStart(UploadFile));
			t.IsBackground = true;
			t.Start();
		}
		//t@C_E[h
		private void DownloadFile()
		{
			SetFileTransMode(DownloadFileName);
			if(rbtn_Port.Checked)
			{
				TcpListener tcpListener = new TcpListener(LocalIP(),0);
				tcpListener.Start();
				SendToServer("PORT "+LocalInfo(tcpListener));
				if(GetMessage()!=200)
					return;
				SendToServer("RETR " + DownloadFileName);
        Socket sock = tcpListener.AcceptSocket();
				GetMessage();
				WriteToLocal(ref sock);
				tcpListener.Stop();
			}
			else
			{
				IPEndPoint Server = null;
				Server = PasvServerInfo();
				if(Server==null)
					return;
				Socket socket = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);
				try
				{
					socket.Connect(Server);
				}
				catch
				{
					tbox_Show.AppendText("f[^RlNVmł܂\r\n");
					return;
				}
				SendToServer("RETR " + DownloadFileName);
				GetMessage();
				WriteToLocal(ref socket);
			}
			GetMessage();
			LocalFileList(LocalPath);
		}
		//_E[hf[^[Jɏ
		private void WriteToLocal(ref Socket socket)
		{
			//ASCII[h
			if(DownloadFileName.IndexOf("txt")>0 ||
				DownloadFileName.IndexOf("ini")>0 ||
				DownloadFileName.IndexOf("bat")>0)
			{
				string m = ReadListFromServer(ref socket);
				StringReader sr = new StringReader(m);
				string temp = "";
				byte[] bb = new byte[256];
				LocalPath = Directory.GetCurrentDirectory();
				string LocalFileName = LocalPath + "\\" + DownloadFileName;
				FileStream fs = new FileStream(LocalFileName,FileMode.OpenOrCreate,FileAccess.Write);
				while((temp = sr.ReadLine())!=null)
				{
					temp += "\r\n";
					bb = Encoding.ASCII.GetBytes(temp);
					fs.Write(bb,0,bb.Length);
					fs.Flush();
				}
				try
				{
					fs.Close();
					socket.Shutdown(SocketShutdown.Both);
					socket.Close();
				}
				catch
				{}
			}
			//BINARY[h
			else
			{
				byte[] bb = new byte [8];
				int count;
				LocalPath = Directory.GetCurrentDirectory();
				string LocalFileName = LocalPath + "\\" + DownloadFileName;
				FileStream fs = new FileStream(LocalFileName,FileMode.OpenOrCreate,FileAccess.Write);
				for(;(count = socket.Receive(bb))>0;)
				{
					fs.Write(bb,0,bb.Length);
					fs.Flush();
				}
				try
				{
					fs.Close();
					socket.Shutdown(SocketShutdown.Both);
					socket.Close();
				}
				catch
				{}
			}
		}
    //t@CAbv[h
		private void UploadFile()
		{
			SetFileTransMode(UploadFileName);
			if(rbtn_Port.Checked)
			{
				TcpListener tcpListener = new TcpListener(LocalIP(),0);
				tcpListener.Start();
				SendToServer("PORT "+LocalInfo(tcpListener));
				if(GetMessage()!=200)
					return;
				SendToServer("STOR "+UploadFileName);
				int code = GetMessage();
				Socket sock = tcpListener.AcceptSocket();
				if(code!=125 && code!=150)
				{
					sock.Shutdown(SocketShutdown.Both);
					sock.Close();
					tcpListener.Stop();
					return;
				}
				SendFromLocal(ref sock);
				tcpListener.Stop();
			}
			else
			{
				IPEndPoint Server = null;
				Server = PasvServerInfo();
				if(Server==null)
					return;
				Socket socket = new Socket(AddressFamily.InterNetwork,SocketType.Stream,ProtocolType.Tcp);
				try
				{
					socket.Connect(Server);
				}
				catch
				{
					tbox_Show.AppendText("f[^RlNVmł܂\r\n");
					return;
				}
				SendToServer("STOR "+UploadFileName);
				int code = GetMessage();
				if(code!=125 && code!=150)
				{
					socket.Shutdown(SocketShutdown.Both);
					socket.Close();
					return;
				}
				SendFromLocal(ref socket);
			}
			GetMessage();
			RemoteFileList();
		}
		//[Jt@Cǂݎ\PbgđM
		private void SendFromLocal(ref Socket socket)
		{
			FileStream fs = new FileStream(UploadFileName,FileMode.Open,FileAccess.Read);
			//eLXgt@C txt batȂ
			if(UploadFileName.IndexOf("txt")>0 ||
				 UploadFileName.IndexOf("ini")>0 ||
				 UploadFileName.IndexOf("bat")>0)
			{
				StreamReader sr = new StreamReader(UploadFileName);
				byte[] bb = new byte[256];
				string textline = "";
				while(sr.Peek()>=0)
				{
					textline = sr.ReadLine()+"\r\n";
					bb = Encoding.UTF8.GetBytes(textline.ToCharArray());
					socket.Send(bb);
				}
			}
			else
			{
				byte[] bb = new byte[8];
				while(fs.Read(bb,0,bb.Length)!=0)
				{
					socket.Send(bb);
				}
			}
			fs.Close();
			socket.Shutdown(SocketShutdown.Both);
			socket.Close();
		}

		//ReLXgj[̎
		private void contextMenu_Local_Popup(object sender, System.EventArgs e)
		{
			menuItem1.Text = "폜";
			menuItem2.Text = "";
			menuItem3.Text = "fBNg̍쐬";
			Point p;
			p = Control.MousePosition;
			p = listView_Local.PointToClient(p);
			lvi = listView_Local.GetItemAt(p.X,p.Y);
			contextMenu_Local.MenuItems.Clear();
			if(lvi==null)
			{
				contextMenu_Local.MenuItems.Add(menuItem3);
			}
			else
			{
				if(lvi.SubItems[3].Text=="0")
					return;
        contextMenu_Local.MenuItems.Add(menuItem1);
				contextMenu_Local.MenuItems.Add(menuItem2);
			}
		}
		//ReLXgj[̎
		private void contextMenu_Remote_Popup(object sender, System.EventArgs e)
		{
			menuItem4.Text = "폜";
			menuItem5.Text = "";
			menuItem6.Text = "fBNg̍쐬";
			Point p;
			p = Control.MousePosition;
			p = listView_Remote.PointToClient(p);
			lvi = listView_Remote.GetItemAt(p.X,p.Y);
			contextMenu_Remote.MenuItems.Clear();
			if(lvi==null)
			{
				contextMenu_Remote.MenuItems.Add(menuItem6);
			}
			else
			{
				contextMenu_Remote.MenuItems.Add(menuItem4);
				contextMenu_Remote.MenuItems.Add(menuItem5);
			}
		
		}
		//([Jjw肷t@C邢̓fBNg폜
		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			if(lvi.SubItems[3].Text=="2")
			{
				try
				{
					File.Delete(lvi.Text);
				}
				catch
				{}
			}
			else
			{
				try
				{
					//폜fBNg͋łȂ΍폜łȂ
					Directory.Delete(lvi.Text);
				}
				catch
				{}
			}
				LocalPath = Directory.GetCurrentDirectory();
				LocalFileList(LocalPath);
		}
		//ACe
		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			Temp = lvi.Text;
			lvi.BeginEdit();
		}
		private void listView_Local_AfterLabelEdit(object sender, System.Windows.Forms.LabelEditEventArgs e)
		{
			string filename = e.Label;
			if(Temp==filename || Temp == "")
				return;
			try
			{
				Directory.Move(Temp,filename);
				LocalPath = Directory.GetCurrentDirectory();
			}
			catch
			{}
			LocalFileList(LocalPath);
		}
		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			try
			{
				Directory.CreateDirectory("VfBNg");
			}
			catch
			{}
			LocalPath = Directory.GetCurrentDirectory();
			LocalFileList(LocalPath);		
		}
		//([Ώjw肷t@C邢̓fBNg폜
		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			if(lvi.SubItems[3].Text=="2")
			{
				SendToServer("DELE "+lvi.Text);
				GetMessage();
				RemoteFileList();
			}
			else
			{
				SendToServer("RMD "+lvi.Text);
				GetMessage();
				RemoteFileList();
			}
		}
    //iT[ojt@C
		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			Temp = lvi.Text;
			lvi.BeginEdit();
		}
		private void listView_Remote_AfterLabelEdit(object sender, System.Windows.Forms.LabelEditEventArgs e)
		{
			string filename = e.Label;
			SendToServer("RNFR "+Temp);
			if(GetMessage()==350)
			{
				SendToServer("RNTO "+filename);
				GetMessage();
			}
			RemoteFileList();
		}
		//iT[ojVfBNg쐬
		private void menuItem6_Click(object sender, System.EventArgs e)
		{
      SendToServer("MKD "+"newdir");
			GetMessage();
			RemoteFileList();
		}


	}
}
